# remirepo/fedora spec file for php-tecnickcom-tc-lib-pdf
#
# SPDX-FileCopyrightText:  Copyright 2023-2024 Remi Collet
# SPDX-License-Identifier: CECILL-2.1
# http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
#
# Please, preserve the changelog entries
#
%global gh_commit    b4f3b51aa0f2aa4452fa3cb1458ee6c8ba15c0dd
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global c_vendor     tecnickcom
%global gh_owner     tecnickcom
%global gh_project   tc-lib-pdf
%global php_project  %{_datadir}/php/Com/Tecnick/Pdf
%bcond_without       tests

Name:           php-%{gh_owner}-%{gh_project}
Version:        8.1.5
Release:        1%{?dist}
Summary:        PHP PDF Library

License:        LGPL-3.0-or-later
URL:            https://github.com/%{gh_owner}/%{gh_project}
Source0:        https://github.com/%{gh_owner}/%{gh_project}/archive/%{gh_commit}/%{name}-%{version}-%{?gh_short}.tar.gz

BuildArch:      noarch
%if %{with tests}
# For tests
%global phpunit %{_bindir}/phpunit10
BuildRequires:  phpunit10 >= 10.5.40
BuildRequires:  php(language) >= 8.1
BuildRequires: (php-composer(%{c_vendor}/tc-lib-barcode)      >= 2.4    with php-composer(%{c_vendor}/tc-lib-barcode)      < 3)
BuildRequires: (php-composer(%{c_vendor}/tc-lib-color)        >= 2.2    with php-composer(%{c_vendor}/tc-lib-color)        < 3)
BuildRequires: (php-composer(%{c_vendor}/tc-lib-pdf-image)    >= 2.1    with php-composer(%{c_vendor}/tc-lib-pdf-image)    < 3)
BuildRequires: (php-composer(%{c_vendor}/tc-lib-pdf-font)     >= 2.6    with php-composer(%{c_vendor}/tc-lib-pdf-font)     < 3)
BuildRequires: (php-composer(%{c_vendor}/tc-lib-file)         >= 2.2    with php-composer(%{c_vendor}/tc-lib-file)         < 3)
BuildRequires: (php-composer(%{c_vendor}/tc-lib-pdf-encrypt)  >= 2.1    with php-composer(%{c_vendor}/tc-lib-pdf-encrypt)  < 3)
BuildRequires: (php-composer(%{c_vendor}/tc-lib-unicode-data) >= 2.0    with php-composer(%{c_vendor}/tc-lib-unicode-data) < 3)
BuildRequires: (php-composer(%{c_vendor}/tc-lib-unicode)      >= 2.0    with php-composer(%{c_vendor}/tc-lib-unicode)      < 3)
BuildRequires: (php-composer(%{c_vendor}/tc-lib-pdf-page)     >= 4.2    with php-composer(%{c_vendor}/tc-lib-pdf-page)     < 5)
BuildRequires: (php-composer(%{c_vendor}/tc-lib-pdf-graph)    >= 2.3    with php-composer(%{c_vendor}/tc-lib-pdf-graph)    < 3)
BuildRequires:  php-date
BuildRequires:  php-openssl
BuildRequires:  php-pcre
# Optional but required for test
BuildRequires:  php-pecl-imagick
%endif
BuildRequires:  php-fedora-autoloader-devel

# From composer.json, "require": {
#    "php": ">=8.1",
#    "ext-date": "*",
#    "ext-pcre": "*",
#    "tecnickcom/tc-lib-barcode": "^2.4",
#    "tecnickcom/tc-lib-color": "^2.2",
#    "tecnickcom/tc-lib-pdf-image": "^2.1",
#    "tecnickcom/tc-lib-pdf-font": "^2.6",
#    "tecnickcom/tc-lib-file": "^2.2",
#    "tecnickcom/tc-lib-pdf-encrypt": "^2.1",
#    "tecnickcom/tc-lib-unicode-data": "^2.0",
#    "tecnickcom/tc-lib-unicode": "^2.0",
#    "tecnickcom/tc-lib-pdf-page": "^4.2",
#    "tecnickcom/tc-lib-pdf-graph": "^2.3"
Requires:       php(language) >= 8.1
Requires:       php-date
Requires:       php-pcre
Requires:      (php-composer(%{c_vendor}/tc-lib-barcode)      >= 2.4    with php-composer(%{c_vendor}/tc-lib-barcode)      < 3)
Requires:      (php-composer(%{c_vendor}/tc-lib-color)        >= 2.2    with php-composer(%{c_vendor}/tc-lib-color)        < 3)
Requires:      (php-composer(%{c_vendor}/tc-lib-pdf-image)    >= 2.1    with php-composer(%{c_vendor}/tc-lib-pdf-image)    < 3)
Requires:      (php-composer(%{c_vendor}/tc-lib-pdf-font)     >= 2.6    with php-composer(%{c_vendor}/tc-lib-pdf-font)     < 3)
Requires:      (php-composer(%{c_vendor}/tc-lib-file)         >= 2.2    with php-composer(%{c_vendor}/tc-lib-file)         < 3)
Requires:      (php-composer(%{c_vendor}/tc-lib-pdf-encrypt)  >= 2.1    with php-composer(%{c_vendor}/tc-lib-pdf-encrypt)  < 3)
Requires:      (php-composer(%{c_vendor}/tc-lib-unicode-data) >= 2.0    with php-composer(%{c_vendor}/tc-lib-unicode-data) < 3)
Requires:      (php-composer(%{c_vendor}/tc-lib-unicode)      >= 2.0    with php-composer(%{c_vendor}/tc-lib-unicode)      < 3)
Requires:      (php-composer(%{c_vendor}/tc-lib-pdf-page)     >= 4.2    with php-composer(%{c_vendor}/tc-lib-pdf-page)     < 5)
Requires:      (php-composer(%{c_vendor}/tc-lib-pdf-graph)    >= 2.3    with php-composer(%{c_vendor}/tc-lib-pdf-graph)    < 3)
# From phpcompatinfo report for version 8.0.53
Requires:       php-openssl
Requires:       php-composer(fedora/autoloader)

# Composer
Provides:       php-composer(%{c_vendor}/%{gh_project}) = %{version}
# Upstream package name
Provides:       php-%{gh_project} = %{version}


%description
PHP library for generating PDF documents on-the-fly.

Main Features:
* no external libraries are required for the basic functions;
* all standard page formats, custom page formats, custom margins and units of measure;
* UTF-8 Unicode and Right-To-Left languages;
* TrueTypeUnicode, OpenTypeUnicode v1, TrueType, OpenType v1, Type1 and CID-0 fonts;
* font subsetting;
* methods to publish some XHTML + CSS code, Javascript and Forms;
* images, graphic (geometric figures) and transformation methods;
* supports JPEG, PNG and SVG images natively, all images supported by GD
  (GD, GD2, GD2PART, GIF, JPEG, PNG, BMP, XBM, XPM) and all images supported
  via ImagMagick (http://www.imagemagick.org/script/formats.php)
* 1D and 2D barcodes: CODE 39, ANSI MH10.8M-1983, USD-3, 3 of 9, CODE 93,
  USS-93, Standard 2 of 5, Interleaved 2 of 5, CODE 128 A/B/C, 2 and 5 Digits
  UPC-Based Extension, EAN 8, EAN 13, UPC-A, UPC-E, MSI, POSTNET, PLANET,
  RMS4CC (Royal Mail 4-state Customer Code), CBC (Customer Bar Code),
  KIX (Klant index - Customer index), Intelligent Mail Barcode, Onecode,
  USPS-B-3200, CODABAR, CODE 11, PHARMACODE, PHARMACODE TWO-TRACKS, Datamatrix,
  QR-Code, PDF417;
* JPEG and PNG ICC profiles, Grayscale, RGB, CMYK, Spot Pdfs and Transparencies;
* automatic page header and footer management;
* document encryption up to 256 bit and digital signature certifications;
* transactions to UNDO commands;
* PDF annotations, including links, text and file attachments;
* text rendering modes (fill, stroke and clipping);
* multiple columns mode;
* no-write page regions;
* bookmarks, named destinations and table of content;
* text hyphenation;
* text stretching and spacing (tracking);
* automatic page break, line break and text alignments including justification;
* automatic page numbering and page groups;
* move and delete pages;
* page compression (requires php-zlib extension);
* XOBject Templates;
* Layers and object visibility.
* PDF/A-1b support.


%prep
%setup -q -n %{gh_project}-%{gh_commit}

: Sanity check
grep -q '^%{version}$' VERSION

: Fix the examples
sed -e 's:^require:////require:' \
    -e 's:^//require:require:'   \
    -e 's:../vendor/tecnickcom/tc-lib-pdf-font/target/fonts/:/usr/share/php-tecnickcom-tc-lib-pdf-font/:' \
    -e '/OUTPUT_FILE/s:../target/:./:' \
    -e 's:../vendor/tecnickcom/tc-lib-pdf-image/test/images:/usr/share/doc/php-tecnickcom-tc-lib-pdf-image/images:' \
    -i examples/*php


%build
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{_datadir}/php/Com/Tecnick/Barcode/autoload.php',
    '%{_datadir}/php/Com/Tecnick/Color/autoload.php',
    '%{_datadir}/php/Com/Tecnick/File/autoload.php',
    '%{_datadir}/php/Com/Tecnick/Pdf/Image/autoload.php',
    '%{_datadir}/php/Com/Tecnick/Pdf/Font/autoload.php',
    '%{_datadir}/php/Com/Tecnick/Pdf/Encrypt/autoload.php',
    '%{_datadir}/php/Com/Tecnick/Pdf/Page/autoload.php',
    '%{_datadir}/php/Com/Tecnick/Pdf/Graph/autoload.php',
    '%{_datadir}/php/Com/Tecnick/Unicode/autoload.php',
    '%{_datadir}/php/Com/Tecnick/Unicode/Data/autoload.php',
]);
EOF


%install
mkdir -p   $(dirname %{buildroot}%{php_project})
cp -pr src %{buildroot}%{php_project}


%check
%if %{with tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require '%{buildroot}%{php_project}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('Test\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" php81 php82 php83 php84; do
   if which $cmdarg; then
      set $cmdarg
      cp phpunit.xml.dist phpunit.xml
      $1 ${2:-%{_bindir}/phpunit10} --migrate-configuration || :
      $1 ${2:-%{_bindir}/phpunit10} \
        --no-coverage --stderr || ret=1
   fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%license LICENSE
%doc composer.json
%doc *.md examples
%{php_project}/*


%changelog
* Mon Jun 23 2025 Remi Collet <remi@remirepo.net> - 8.1.5-1
- update to 8.1.5

* Tue Jun 10 2025 Remi Collet <remi@remirepo.net> - 8.1.2-1
- update to 8.1.2

* Sat Jun  7 2025 Remi Collet <remi@remirepo.net> - 8.0.91-1
- update to 8.0.91
- raise dependency on tc-lib-pdf-graph 2.3

* Wed May 28 2025 Remi Collet <remi@remirepo.net> - 8.0.89-1
- update to 8.0.89
- raise dependency on tc-lib-file 2.2

* Wed May 14 2025 Remi Collet <remi@remirepo.net> - 8.0.88-1
- update to 8.0.88

* Mon Apr 28 2025 Remi Collet <remi@remirepo.net> - 8.0.86-1
- update to 8.0.86

* Fri Feb  7 2025 Remi Collet <remi@remirepo.net> - 8.0.85-1
- update to 8.0.85

* Fri Dec 27 2024 Remi Collet <remi@remirepo.net> - 8.0.84-1
- update to 8.0.84
- raise dependency on PHP 8.1

* Mon Dec 23 2024 Remi Collet <remi@remirepo.net> - 8.0.83-1
- update to 8.0.83
- raise dependency on tecnickcom/tc-lib-file 2.1
- re-license spec file to CECILL-2.1

* Mon Nov 25 2024 Remi Collet <remi@remirepo.net> - 8.0.82-1
- update to 8.0.82
- raise dependency on tc-lib-barcode 2.4

* Mon Oct 28 2024 Remi Collet <remi@remirepo.net> - 8.0.81-1
- update to 8.0.81
- raise dependency on tc-lib-barcode 2.3
- raise dependency on tc-lib-pdf-font 2.6
- raise dependency on tc-lib-pdf-graph 2.2

* Tue Aug 27 2024 Remi Collet <remi@remirepo.net> - 8.0.77-1
- update to 8.0.77
- raise dependency on tc-lib-pdf-page 4.2

* Tue Aug 27 2024 Remi Collet <remi@remirepo.net> - 8.0.75-1
- update to 8.0.75

* Mon Aug 26 2024 Remi Collet <remi@remirepo.net> - 8.0.74-1
- update to 8.0.74
- raise dependency on tc-lib-pdf-font 2.5
- raise dependency on tc-lib-pdf-page 4.1

* Mon Aug 19 2024 Remi Collet <remi@remirepo.net> - 8.0.71-1
- update to 8.0.71
- raise dependency on tc-lib-color 2.2
- raise dependency on tc-lib-pdf-image 2.1
- raise dependency on tc-lib-pdf-font 2.4
- raise dependency on tc-lib-pdf-graph 2.1

* Thu Aug 15 2024 Remi Collet <remi@remirepo.net> - 8.0.66-1
- update to 8.0.66

* Wed Aug 14 2024 Remi Collet <remi@remirepo.net> - 8.0.64-1
- update to 8.0.64

* Thu Aug  1 2024 Remi Collet <remi@remirepo.net> - 8.0.62-1
- update to 8.0.62

* Fri Apr 12 2024 Remi Collet <remi@remirepo.net> - 8.0.60-1
- update to 8.0.60
- raise dependency on tc-lib-barcode 2.2
- raise dependency on tc-lib-pdf-font 2.2

* Thu Nov 30 2023 Remi Collet <remi@remirepo.net> - 8.0.55-1
- update to 8.0.55
- raise dependency on tc-lib-pdf-encrypt 2.1

* Wed Nov 29 2023 Remi Collet <remi@remirepo.net> - 8.0.53-1
- initial package, version 8.0.53
